# sfsmc
More than a web server that dynamically show the status of a Minecraft server (formerly known as bukkit-server-status)

# Goals
- [x] A daemon/service (`sfsmcd`/`sfsmc`) that can be controlled via [DBus](https://www.freedesktop.org/wiki/Software/dbus/)
    - [x] systemd integration
    - [x] DBus integration
    - [x] A Minecraft server (starting, eventually stopping) _(needs testing)_
    - [ ] A web server for the status page
        - [ ] Online status
        - [ ] Players
        - [ ] MOTD
        - [ ] Start the Minecraft server if it is offline
    - [ ] Web server extensions (via dynamic libraries) _(just maaaayyybeee)_
- [x] A CLI (`sfsmcctl`) that enables to
    - [x] Start the daemon/service
    - [x] Stop the daemon/service
    - [x] Start the Minecraft server _(needs testing)_
    - [ ] Give control over the Minecraft server terminal
    - [ ] Stop the Minecraft server
    - [ ] Start the web server
    - [ ] Stop the web server
- [ ] Config loading
- [ ] Config profiles

# Dependencies
## Non-Rust dependencies
- [systemd](https://systemd.io/)
- [DBus](https://www.freedesktop.org/wiki/Software/dbus/)
- Any Minecraft server e.g. [Spigot](https://www.spigotmc.org/)
- [screen](https://www.gnu.org/software/screen/)

## Crates
- [clap](https://crates.io/crates/clap/) v2.33
- [tokio](https://crates.io/crates/tokio/) v0.2 (although v0.3 is out already)
- [dbus](https://crates.io/crates/dbus/) v0.9
- [dbus-tokio](https://crates.io/crates/dbus-tokio/) v0.6
- [dbus-tree](https://crates.io/crates/dbus-tree/) v0.9
- [log](https://crates.io/crates/log/) v0.4
- [env_logger](https://crates.io/crates/env_logger/) v0.8
- [async-minecraft-ping](https://crates.io/crates/async-minecraft-ping/)
- [toml](https://crates.io/crates/toml/)
- [actix-web](https://crates.io/crates/actix-web/)